<template>
  <q-page class="q-mx-md">
    <div class="row">
      <q-card class="q-ma-md q-pa-md col " flat>
        <q-uploader field-name="tax_package" accept=".zip" id="tax_package" label="Upload taxonomy package"
                    max-files=1 ref="fileUploader" auto-upload name="tax_package"
                    :factory="zipFactory"
                    @uploaded="show_taxonomyPackage_response"
                    @failed="package_fail"
                    :url="taxonomyPackageURL"
                    class="full-width bg-grey-1" flat square bordered
                    @abort="dummy_abort"
        ></q-uploader>
        <q-card class="q-ma-sm full-width bg-grey-1" flat>
          <p>We verwachten hier een zipfile in <a
            href="https://www.xbrl.org/Specification/taxonomy-package/PR-2015-12-09/taxonomy-package-PR-2015-12-09.html#taxonomy-package">het
            taxonomy package formaat</a>.<br/>
            Het is mogelijk dat er een extra archief is gemaakt van een of meerdere
            taxonomy-packages. In dat geval moet je die lokaal uitpakken en dan uploaden</p>
        </q-card>
        <div class="row">
          <div class="col-12 q-mb-md">
            <q-input v-if="xbrl_cli.taxonomy_package" v-model="xbrl_cli.taxonomy_package" disable
                     square outlined
                     hint="Dit is de locatie van het package na uploaden op de server">
            </q-input>
          </div>
        </div>
        <div class="row">
          <div class="col-12">
            <q-input v-model="xbrl_cli.nt_version" label="[NT] Versie"
                     square outlined
                     hint="Dit is de naam waaronder de entrypoints teruggevonden kunnen worden onde de
                     dropdown 'NT-Versie'"></q-input>
          </div>
        </div>

        <div class="row">
          <div class="col">
            <template v-if="meta_data.entrypoints && meta_data.entrypoints.length">
              <q-card-section class="detail_bg q-mt-md">
                <q-item-label class="text-h5">gevonden Entrypoints</q-item-label>
                <q-input label="filter" v-model="search_value" title="Filter entrypoints by name" outlined square
                         class="q-my-sm bg-white">
                  <template v-slot:prepend>
                    <q-icon name="filter_alt"/>
                  </template>
                  <template v-if="search_value" v-slot:append>
                    <q-icon name="cancel" @click.stop.prevent="search_value = ''" class="cursor-pointer"/>
                  </template>
                </q-input>

                <q-option-group v-model="parse_list" type="checkbox" :options="ep_options_filtered" dense
                                class="bg-white q-ml-xs">
                  <template v-slot:label="opt">
                    <q-item class="row">
                      <q-item-label class="row">
                        <div>{{ opt.label }}</div>
                        <div class="text-caption">{{ opt.description }}</div>
                      </q-item-label>
                    </q-item>
                  </template>
                </q-option-group>
              </q-card-section>
            </template>
          </div>
        </div>

        <div class="row">
          <div class="col">
            <q-checkbox label="Parse" v-model="xbrl_cli.parse" disable></q-checkbox>
          </div>
          <div class="col">
            <q-checkbox label="Valideer" v-model="xbrl_cli.validate_nt" @click="set_btn_label"></q-checkbox>
          </div>
          <div class="col">
            <q-checkbox label="Sla op en toon in Nessie" v-model="xbrl_cli.store"></q-checkbox>
          </div>
        </div>
        <div class="row">
          <div class="col">
            <q-input name="notify" label="E-mailadres" v-model="xbrl_cli.notify" type="email" class="q-mx-sm"
                     hint="Wanneer alles klaar is sturen we een e-mail naar dit adres (optioneel)"></q-input>
          </div>
        </div>
        <div class="row">
          <div class="col-3">
            <q-btn :label="btn_label" @click="parse_package" color="red" class="q-my-md q-px-md"
                   :disable="!parse_available"/>
          </div>
        </div>
      </q-card>
      <ParseConfiguration :configuration="data.taxonomy.configuration" :xbrl_cli="xbrl_cli"
                          :parse_list="parse_list"></ParseConfiguration>

    </div>

    <q-banner v-if="upload_error" class="upload_error_banner text-white bg-red absolute-top q-mt-xl shadow-3">
      De volgende fout is opgetreden:
      <div class="text-bold">{{ last_error }}</div>
      <template v-slot:action>
        <q-btn flat label="Dismiss" @click="upload_error = false" @keydown.esc="upload_error = false"/>
      </template>
    </q-banner>

    <q-banner v-if="upload_warning" class="upload_warning_banner text-black bg-yellow-11 absolute-top q-mt-xl shadow-3">
      Bij het lezen van het taxonomy-package
      <div v-for="warning in last_warnings" :key="warning" class="text-bold">{{ warning }}</div>
      <template v-slot:action>
        <q-btn flat label="Dismiss" @click="upload_warning = false" @keydown.esc="upload_warning = false"/>
      </template>
    </q-banner>

  </q-page>

</template>

<script>
import {api} from "boot/axios";
import ParseConfiguration from "components/ParseConfiguration";
import {useStore} from 'vuex'
import {Cookies} from "quasar";
import _ from 'lodash'

export default {
  name: "TaxonomyPackage",
  components: {ParseConfiguration},
  computed: {
    taxonomyPackageURL() {
      return api.defaults.baseURL + "/admin/upload_taxonomy_package"
    },
    parse_available() {
      return this.xbrl_cli.taxonomy_package > ''
    },
    ep_options_filtered() {
      let filtered = this.ep_options
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        filtered = filtered.filter(ep => ep.label &&
          ep.label.toLowerCase().includes(this.search_value.toLowerCase()))
      }
      return filtered
    }
  },
  created() {
    this.fetchData()
  },
  data() {
    return {
      parse_list: [],
      xbrl_cli: {
        parse: true,
        store: false,
        validate_nt: false,
        compare: false,
        run_id: "",
        build_ep_list: false,
        alfa: false,
        beta: false,
        final: true,
        nt_version: "Unknown",
        taxonomy_package: "",
        notify: "",
        ep_list: [],
      },
      data: {taxonomy: Object},
      btn_label: "Parse",
      ep_options: [],
      upload_error: false,
      upload_warning: false,
      last_error: undefined,
      last_warnings: [],
      meta_data: Object,
      search_value: "",
      url: "",
    }
  },
  methods: {
    fetchData: function () {
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .get("/admin/taxonomy", {headers})
        .then(response => {
          this.data.taxonomy = response.data
          if (this.data.taxonomy.configuration.parser.notify && !this.xbrl_cli.notify) {
            this.xbrl_cli.notify = this.data.taxonomy.configuration.parser.notify
          }
          // if the current Nessie admin user has en email address, use that one
          if (this.$store.state.user.User.email) {
            this.xbrl_cli.notify = this.$store.state.user.User.email
          }
        })
        .catch((error) => {
          console.log(error.response.status)
          if (error.response.status == 401) {
            this.$store.commit('user/LOGOUT', '')
            if (Cookies.has('kc_token')) {
              Cookies.remove('kc_token')
            }
            this.$store.commit('user/LOGIN_ERROR', 'Sessie verlopen, log opnieuw in')
          }
        })

    },
    zipFactory: function (file) {
      if (this.$store.state.user.token) {
        return new Promise((resolve, reject) => {
          resolve({
            method: 'POST',
            headers: [{name: "Authorization", value: "Bearer " + this.$store.state.user.token}],
            fieldName: "zipfiles",
            responseType: 'json'
          })
        })
      }
    },
    show_taxonomyPackage_response(info) {
      let response = JSON.parse(info.xhr.responseText)
      this.meta_data = response.info
      this.xbrl_cli.taxonomy_package = response.filename
      this.xbrl_cli.nt_version = response.nt_version
      if (response.messages) {
        this.upload_warning = true
        this.last_warnings = response.messages
      }
      response.info.entrypoints.forEach((ep) => {
        this.ep_options.push(
          {
            label: ep.name,
            value: ep.name,
            description: ep.description,
          }
        )
      })


    },
    package_fail(info) {
      let response = JSON.parse(info.xhr.responseText)
      this.upload_error = true
      this.last_error = response.detail.error
    },
    dummy_abort: function (file) {
      return true
    },
    set_btn_label: function () {
      this.btn_label = "Parse"
    },
    parse_package: function () {
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .post("/admin/load_tax", {
          "conf": this.data.taxonomy,
          "cli": this.xbrl_cli,
          "ep_list": this.parse_list
        }, {headers})
      this.$router.push({path: this.$route.fullPath, query: {pos: 0}})
    },

  }
}
</script>

<style scoped>

</style>
